#ifndef MAX6950_H
#define	MAX6950_H
//------------------------Dot Matrix LED  Driver--------------------------------
#include <string.h>
#include "../Soft_SPI/Soft_SPI.h"
#include "MAX6950_Prototypes.h"
//------------------------------------------------------------------------------
void MAX6950_init()
{
  SPI_init();
  
  MAX6950_write(DECODE_MODE_REG, DISABLE_DECODE);    
  MAX6950_write(INTESITY_REG, BRIGHTNESS);     
  MAX6950_write(SCAN_LIMIT_REG, SCAN_LOW_NIBBLE);
  MAX6950_write(SHUTDOWN_REG, NORMAL_OPERATION);
}
//------------------------------------------------------------------------------
void MAX6950_write(char reg,signed char data)
{
  CS = 0; 
  
  SPI_write(reg); 
  SPI_write(data); 
  
  CS = 1;
}
//------------------------------------------------------------------------------
void MAX6950_displayNumber(signed int number)
{   
  char strNum[15]; 
  sprintf(strNum,"%4i",number);
  
  for(char i = 0; i < strlen(strNum); i++)
  {    
    char digit = getDigit(strNum[i], i);
    MAX6950_write( DISPLAY_REG0 + i, digit );
  }
}
//------------------------------------------------------------------------------
char getDigit(char asciiChar, char pos)
{
    char digit = 0;
    
    if(asciiChar >= '0' && asciiChar <= '9') 
    {
        char i = asciiChar - '0';
        digit = (pos == 2) ? (digits[i] + DECIMAL_POINT) : digits[i];
    }
    else
        if(asciiChar == '-')
        {
            digit = (pos == 2) ? (digits[0] + DECIMAL_POINT) : 0x01;  //0x01 - minus symbol
        }
        else
            if(asciiChar == ' ')
            {
                digit = (pos == 2) ? (digits[0] + DECIMAL_POINT) : 0x00; //0x00 - blank. used for leading zero suppression
            }
    
    return digit;
}
//------------------------------------------------------------------------------
#endif	